Loading...
Searching...
No Matches
juce::AudioFormat Class Referenceabstract

## Detailed Description

Subclasses of AudioFormat are used to read and write different audio file formats.

See also
  AudioFormatReader, AudioFormatWriter, WavAudioFormat, AiffAudioFormat

The documentation for this class was generated from the following file:

- juce_audio_formats/format/juce_AudioFormat.h

Inheritance diagram for juce::AudioFormat:

## Public Member Functions

virtual | ~AudioFormat ()
| Destructor.
const String & | getFormatName () const
| Returns the name of this format.
virtual StringArray | getFileExtensions () const
| Returns all the file extensions that might apply to a file of this format.
virtual bool | canHandleFile (const File &fileToTest)
| Returns true if this the given file can be read by this format.
virtual Array< int > | getPossibleSampleRates ()=0
| Returns a set of sample rates that the format can read and write.
virtual Array< int > | getPossibleBitDepths ()=0
| Returns a set of bit depths that the format can read and write.
virtual bool | canDoStereo ()=0
| Returns true if the format can do 2-channel audio.
virtual bool | canDoMono ()=0
| Returns true if the format can do 1-channel audio.
virtual bool | isCompressed ()
| Returns true if the format uses compressed data.
virtual bool | isChannelLayoutSupported (const AudioChannelSet &channelSet)
| Returns true if the channel layout is supported by this format.
virtual StringArray | getQualityOptions ()
| Returns a list of different qualities that can be used when writing.
virtual AudioFormatReader * | createReaderFor (InputStream *sourceStream, bool deleteStreamIfOpeningFails)=0
| Tries to create an object that can read from a stream containing audio data in this format.
virtual MemoryMappedAudioFormatReader * | createMemoryMappedReader (const File &file)
| Attempts to create a MemoryMappedAudioFormatReader, if possible for this format.
virtual MemoryMappedAudioFormatReader * | createMemoryMappedReader (FileInputStream *fin)
virtual std::unique_ptr< AudioFormatWriter > | createWriterFor (std::unique_ptr< OutputStream > &streamToWriteTo, const AudioFormatWriterOptions &options)=0
| Tries to create an object that can write to a stream with this audio format.
AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format.
AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, const AudioChannelSet &channelLayout, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format.

## Protected Member Functions

| AudioFormat (String formatName, StringArray fileExtensions)
| Creates an AudioFormat object.
| AudioFormat (StringRef formatName, StringRef fileExtensions)
| Creates an AudioFormat object.

## Constructors and Destructors

## ~AudioFormat()

virtual juce::AudioFormat::~AudioFormat | ( |  | ) |

virtual

Destructor.

## AudioFormat() [1/2]

juce::AudioFormat::AudioFormat | ( | String | formatName,
|  | StringArray | fileExtensions )

protected

Creates an AudioFormat object.

Parameters

  formatName | this sets the value that will be returned by getFormatName()
  fileExtensions | an array of file extensions - these will be returned by getFileExtensions()

## AudioFormat() [2/2]

juce::AudioFormat::AudioFormat | ( | StringRef | formatName,
|  | StringRef | fileExtensions )

protected

Creates an AudioFormat object.

Parameters

  formatName | this sets the value that will be returned by getFormatName()
  fileExtensions | a whitespace-separated list of file extensions - these will be returned by getFileExtensions()

## Member Functions

## getFormatName()

const String & juce::AudioFormat::getFormatName | ( |  | ) | const

Returns the name of this format.

e.g. "WAV file" or "AIFF file"

## getFileExtensions()

virtual StringArray juce::AudioFormat::getFileExtensions | ( |  | ) | const

virtual

Returns all the file extensions that might apply to a file of this format.

The first item will be the one that's preferred when creating a new file. So for a wav file this might just return ".wav"; for an AIFF file it might return two items, ".aif" and ".aiff"

## canHandleFile()

virtual bool juce::AudioFormat::canHandleFile | ( | const File & | fileToTest | ) |

virtual

Returns true if this the given file can be read by this format.

Subclasses shouldn't do too much work here, just check the extension or file type. The base class implementation just checks the file's extension against one of the ones that was registered in the constructor.

Reimplemented in juce::AiffAudioFormat, and juce::LAMEEncoderAudioFormat.

## getPossibleSampleRates()

virtual Array< int > juce::AudioFormat::getPossibleSampleRates | ( |  | ) |

pure virtual

Returns a set of sample rates that the format can read and write.

Implemented in juce::AiffAudioFormat, juce::CoreAudioFormat, juce::FlacAudioFormat, juce::LAMEEncoderAudioFormat, juce::MP3AudioFormat, juce::OggVorbisAudioFormat, juce::WavAudioFormat, and juce::WindowsMediaAudioFormat.

## getPossibleBitDepths()

virtual Array< int > juce::AudioFormat::getPossibleBitDepths | ( |  | ) |

pure virtual

Returns a set of bit depths that the format can read and write.

Implemented in juce::AiffAudioFormat, juce::CoreAudioFormat, juce::FlacAudioFormat, juce::LAMEEncoderAudioFormat, juce::MP3AudioFormat, juce::OggVorbisAudioFormat, juce::WavAudioFormat, and juce::WindowsMediaAudioFormat.

## canDoStereo()

virtual bool juce::AudioFormat::canDoStereo | ( |  | ) |

pure virtual

Returns true if the format can do 2-channel audio.

Implemented in juce::AiffAudioFormat, juce::CoreAudioFormat, juce::FlacAudioFormat, juce::LAMEEncoderAudioFormat, juce::MP3AudioFormat, juce::OggVorbisAudioFormat, juce::WavAudioFormat, and juce::WindowsMediaAudioFormat.

## canDoMono()

virtual bool juce::AudioFormat::canDoMono | ( |  | ) |

pure virtual

Returns true if the format can do 1-channel audio.

Implemented in juce::AiffAudioFormat, juce::CoreAudioFormat, juce::FlacAudioFormat, juce::LAMEEncoderAudioFormat, juce::MP3AudioFormat, juce::OggVorbisAudioFormat, juce::WavAudioFormat, and juce::WindowsMediaAudioFormat.

## isCompressed()

virtual bool juce::AudioFormat::isCompressed | ( |  | ) |

virtual

Returns true if the format uses compressed data.

Reimplemented in juce::FlacAudioFormat, juce::LAMEEncoderAudioFormat, juce::MP3AudioFormat, juce::OggVorbisAudioFormat, and juce::WindowsMediaAudioFormat.

## isChannelLayoutSupported()

virtual bool juce::AudioFormat::isChannelLayoutSupported | ( | const AudioChannelSet & | channelSet | ) |

virtual

Returns true if the channel layout is supported by this format.

Reimplemented in juce::WavAudioFormat.

## getQualityOptions()

virtual StringArray juce::AudioFormat::getQualityOptions | ( |  | ) |

virtual

Returns a list of different qualities that can be used when writing.

Non-compressed formats will just return an empty array, but for something like Ogg-Vorbis or MP3, it might return a list of bit-rates, etc.

When calling createWriterFor(), an index from this array is passed in to tell the format which option is required.

Reimplemented in juce::FlacAudioFormat, juce::LAMEEncoderAudioFormat, juce::MP3AudioFormat, and juce::OggVorbisAudioFormat.

## createReaderFor()

virtual AudioFormatReader * juce::AudioFormat::createReaderFor | ( | InputStream * | sourceStream,
|  | bool | deleteStreamIfOpeningFails )

pure virtual

Tries to create an object that can read from a stream containing audio data in this format.

The reader object that is returned can be used to read from the stream, and should then be deleted by the caller.

Parameters

  sourceStream | the stream to read from - the AudioFormatReader object that is returned will delete this stream when it no longer needs it.
  deleteStreamIfOpeningFails | if no reader can be created, this determines whether this method should delete the stream object that was passed-in. (If a valid reader is returned, it will always be in charge of deleting the stream, so this parameter is ignored)

See also
  AudioFormatReader

Implemented in juce::AiffAudioFormat, juce::CoreAudioFormat, juce::FlacAudioFormat, juce::LAMEEncoderAudioFormat, juce::MP3AudioFormat, juce::OggVorbisAudioFormat, juce::WavAudioFormat, and juce::WindowsMediaAudioFormat.

## createMemoryMappedReader() [1/2]

virtual MemoryMappedAudioFormatReader * juce::AudioFormat::createMemoryMappedReader | ( | const File & | file | ) |

virtual

Attempts to create a MemoryMappedAudioFormatReader, if possible for this format.

If the format does not support this, the method will return nullptr;

Reimplemented in juce::AiffAudioFormat, and juce::WavAudioFormat.

## createMemoryMappedReader() [2/2]

virtual MemoryMappedAudioFormatReader * juce::AudioFormat::createMemoryMappedReader | ( | FileInputStream * | fin | ) |

virtual

Reimplemented in juce::AiffAudioFormat, and juce::WavAudioFormat.

## createWriterFor() [1/3]

virtual std::unique_ptr< AudioFormatWriter > juce::AudioFormat::createWriterFor | ( | std::unique_ptr< OutputStream > & | streamToWriteTo,
|  | const AudioFormatWriterOptions & | options )

pure virtual

Tries to create an object that can write to a stream with this audio format.

If the writer can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | a reference to a unique_ptr that owns the output stream. If creating the writer succeeds, then ownership of the stream will be transferred to the writer, and this argument will be set to nullptr. If creating the writer fails, then streamToWriteTo will remain unchanged, allowing it to be reused to create a writer of a different format.
  options | options that specify details of the output file. If the audio format does not support these settings, then this function may return nullptr.

See also
  AudioFormatWriterOptions

Implemented in juce::AiffAudioFormat, juce::CoreAudioFormat, juce::FlacAudioFormat, juce::LAMEEncoderAudioFormat, juce::MP3AudioFormat, juce::OggVorbisAudioFormat, juce::WavAudioFormat, and juce::WindowsMediaAudioFormat.

Referenced by juce::FlacAudioFormat::createReaderFor(), juce::LAMEEncoderAudioFormat::createReaderFor(), juce::AiffAudioFormat::createWriterFor(), juce::CoreAudioFormat::createWriterFor(), juce::MP3AudioFormat::createWriterFor(), juce::OggVorbisAudioFormat::createWriterFor(), juce::WavAudioFormat::createWriterFor(), and juce::WindowsMediaAudioFormat::createWriterFor().

## createWriterFor() [2/3]

AudioFormatWriter * juce::AudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | unsigned int | numberOfChannels,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex )

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

## createWriterFor() [3/3]

AudioFormatWriter * juce::AudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | const AudioChannelSet & | channelLayout,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex )

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  channelLayout | the channel layout for the file. Use isChannelLayoutSupported to check if the writer supports this layout.
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited